# opentl::math::Vector3 Class Reference

Special class for vectors with dimension of three. More...

Inherits opentl::math::Vector.

List of all members.

## Public Member Functions
double | abs () const
| calculates the length of this vector
double | calcStdDeviation () const
| caclulates the standard deviation of this vector
Vector3 | crossProduct (const math::Vector3 &v2)
| Calculate 3D cross product of this,v2.
std::size_t | dimension () const
| get the dimension of this vector (2)
double | dotProduct (const Vector *v2) const
| caclulates the dot product of this vector and another
void | normalize ()
| normailize this vector
Vector4 | toVector4 ()
| Vector3 (double x, double y, double z)
| Constructor taking vector data.
| Vector3 (const Matrix &m)
| Constructor based on an existing matrix.
| Vector3 (const Vector3 &m)
| Constructor based on an existing matrix.
| Vector3 ()
| Constructor.
virtual | ~Vector3 ()
| Destructor.

## Detailed Description

Special class for vectors with dimension of three.

Author:
  Claus Lenz <lenz@in.tum.de>

  Thomas Friedlhuber <friedlhu@in.tum.de>

## Constructor & Destructor Documentation

opentl::math::Vector3::Vector3 | ( |  | ) |

Constructor.

opentl::math::Vector3::Vector3 | ( | const Vector3 & | m | ) |

Constructor based on an existing matrix.

Parameters:

  | m | existing matrix

opentl::math::Vector3::Vector3 | ( | const Matrix & | m | ) | `[explicit]`

Constructor based on an existing matrix.

Parameters:

  | m | existing matrix

opentl::math::Vector3::Vector3 | ( | double | x,
|  | double | y,
|  | double | z |
| ) |  |  | `[inline]`

Constructor taking vector data.

Parameters:

  | x | vector data
  | y | vector data
  | z | vector data

virtual opentl::math::Vector3::~Vector3 | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

double opentl::math::Vector3::abs | ( |  | ) | const`[inline]`

calculates the length of this vector

Returns:
  length

double opentl::math::Vector3::calcStdDeviation | ( |  | ) | const`[inline]`

caclulates the standard deviation of this vector

Returns:
  standard deviation

Vector3 opentl::math::Vector3::crossProduct | ( | const math::Vector3 & | v2 | ) |

Calculate 3D cross product of this,v2.

Parameters:

  | v2 | second vector of cross product

Returns:
  the Vector3 result

std::size_t opentl::math::Vector3::dimension | ( |  | ) | const`[inline, virtual]`

get the dimension of this vector (2)

Returns:
  dimension (=3)

Reimplemented from opentl::math::Vector.

double opentl::math::Vector3::dotProduct | ( | const Vector * | v2 | ) | const

caclulates the dot product of this vector and another

Parameters:

  | v2 | the 2nd vector to be used

Returns:
  dot product

void opentl::math::Vector3::normalize | ( |  | ) | `[inline, virtual]`

normailize this vector

Reimplemented from opentl::math::Vector.

Vector4 opentl::math::Vector3::toVector4 | ( |  | ) |

convert to a four dimension vector